# Class DefaultDocumentRequestHandler

java.lang.Object
com.codename1.ui.html.DefaultDocumentRequestHandler

All Implemented Interfaces:
  `AsyncDocumentRequestHandler, DocumentRequestHandler`

Direct Known Subclasses:
  `AsyncDocumentRequestHandlerImpl`

public class DefaultDocumentRequestHandler extends java.lang.Object implements AsyncDocumentRequestHandler
Default implementation of the HTML components document request handler to allow simple HTML support in Codename One. This version includes only the basics supported by MIDP e.g. resources and jar file URL's such as jar:// and res://

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultDocumentRequestHandler()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Resources`
  `getResFile()`
  Allows URL's referring to a res:// local resource to default to this file
  `boolean`
  `isTrackVisitedURLs()`
  Allows tracking whether a URL was visited or not
  `java.io.InputStream`
  `resourceRequested(DocumentInfo docInfo)`
  Implementations should return the document in the requested url as an InputStream This is triggered only for the main document requested and not for its resources.
  `void`
  `resourceRequestedAsync(DocumentInfo docInfo, IOCallback callback)`
  This method is called by HTMLComponent when a resource is requested asynchronously.
  `static void`
  `setResFile(Resources res)`
  Allows URL's referring to a local:// local resource to default to this file
  `void`
  `setTrackVisitedURLs(boolean trackVisitedURLs)`
  Allows tracking whether a URL was visited or not
  `protected void`
  `visitingURL(String url)`
  This method can be invoked to indicate a URL was visited fro tracking
  `boolean`
  `wasURLVisited(String url)`
  Returns true if the URL was visited, requires trackVisitedURLs to be true

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### DefaultDocumentRequestHandler

    public DefaultDocumentRequestHandler()

- ## Method Details

  - ### getResFile

    public static Resources getResFile()

    Allows URL's referring to a res:// local resource to default to this file

    ###### Returns

    the resFile

  - ### setResFile

    public static void setResFile(Resources res)

    Allows URL's referring to a local:// local resource to default to this file

    ###### Parameters

    - `res`: the resource

  - ### resourceRequestedAsync

    public void resourceRequestedAsync(DocumentInfo docInfo, IOCallback callback)

    This method is called by HTMLComponent when a resource is requested asynchronously. This method should return immediately and start a process of fetching the requested resource on another thread. When the resource was fetched, the HTMLComponent.streamReady should be called.

    ###### Parameters

    - `docInfo`: A DocumentInfo object representing the requested URL and its attributes

    - `callback`: The HTMLComponent that should be called back when the stream was fetched.

    Specified by:
      `resourceRequestedAsync` in interface `AsyncDocumentRequestHandler`

  - ### resourceRequested

    public java.io.InputStream resourceRequested(DocumentInfo docInfo)

    Implementations should return the document in the requested url as an InputStream This is triggered only for the main document requested and not for its resources.

    ###### Parameters

    - `docInfo`: A DocumentInfo object representing the requested URL and its attributes

    ###### Returns

    the document at the URL as an InputStream

    Specified by:
      `resourceRequested` in interface `DocumentRequestHandler`

  - ### visitingURL

    protected void visitingURL(String url)

    This method can be invoked to indicate a URL was visited fro tracking

    ###### Parameters

    - `url`: the url

  - ### wasURLVisited

    public boolean wasURLVisited(String url)

    Returns true if the URL was visited, requires trackVisitedURLs to be true

    ###### Parameters

    - `url`: the url

    ###### Returns

    true if it was visited

  - ### isTrackVisitedURLs

    public boolean isTrackVisitedURLs()

    Allows tracking whether a URL was visited or not

    ###### Returns

    the trackVisitedURLs

  - ### setTrackVisitedURLs

    public void setTrackVisitedURLs(boolean trackVisitedURLs)

    Allows tracking whether a URL was visited or not

    ###### Parameters

    - `trackVisitedURLs`: the trackVisitedURLs to set